// Variables \\
var gameSize;
var grid;
var player1turn;
var playing;


//Main Functions\\
var setup = function() {
  gameSize = 500;
  player1turn = true;
  playing = true;
  resetGrid();
  size(gameSize, gameSize + 100);
  textAlign(CENTER, CENTER);
  drawGame();
};



//Helper Functions\\
var drawGame = function() {
  background(10, 100, 10);
  
  strokeWeight(5);
  fill(0, 0, 0);
  
  let s = gameSize;
  let t = gameSize/3;
  
  line(t, 0, t, s);
  line(2*t, 0, 2*t, s);
  line(s, t, 0, t);
  line(s, 2*t, 0, 2*t);
  
  for (var i = 0; i < grid.length; i++) {
    let x = t/2 + (t * (i % 3));
    let y = t/2 + (t * (floor(i / 3)));
    textSize(128);
    fill(0, 0, 0);
    text(grid[i], x, y);
  }
  
  drawMessage(player1turn ? "Player 1 Turn" : "Player 2 Turn");
};

var drawMessage = function(message) {
  fill(255, 255, 255);
  rect(0, gameSize, gameSize, 100);
  textSize(48);
  fill(0);
  text(message, gameSize/2, gameSize + 50);
};

var resetGrid = function() {
  grid = [];
  for(var i = 0; i < 9; i++) {
    grid.push("");
  }
};

var mousePressed = function() {
  
  if (!playing) {
    setup();
    return;
  }
  
  var ratio = width / document.getElementById("pjs-canvas").clientWidth;
  var mX = mouseX * ratio;
  var mY = mouseY * ratio;
  
  var t = gameSize/3;
  var row = floor(mY / t);
  var col = floor(mX / t);
  var index = 3 * row + col;
  
  if (grid[index] === "") {
    grid[index] = player1turn ? "X" : "O";
    player1turn = !player1turn;
    drawGame();
    
    if (gameOver()) {
      drawMessage("GAME OVER");
      playing = !playing;
    }
  }
};

var gameOver = function() {
  
  var possibleWins = [
  [0, 1, 2],
  [3, 4, 5],
  [6, 7, 8],
  [0, 3, 6],
  [1, 4, 7],
  [2, 5, 8],
  [0, 4, 8],
  [2, 4, 6]
  ];
  
  for (var pw of possibleWins) {
    let array = [];    for (var n of pw) {
      array.push(grid[n]);
      if(array.indexOf("") === -1) {
      if (array[0] == array[1] && array[0] == array[2]) {
        let t = gameSize / 3;
        
        let x1 = t / 2 + (t * (pw[0] % 3));
        let y1 = t / 2 + (t * (floor(pw[0] / 3)));
        let x2 = t / 2 + (t * (pw[2] % 3));
        let y2 = t / 2 + (t * (floor(pw[2] / 3)));
        
        stroke(255, 0, 0);
        strokeWeight(5);
        line(x1, y1, x2, y2);

        
        return true;
      }
      }
    }
    
      
    
  }
  
  if (grid.indexOf("") === -1) {
    return true;
  }
  
   return false;
};